\ load.asm
\
\ Program to load another program to RAM, and execute it.

fload f.f
start

: ok  $bb # uart-write ;
: init  $17 # uart-init ;
: reset  $01000080 a# ok ;
: store  uart-read c!+ ok ;
: fetch  c@+ uart-write ok ;
: run  ok $01000080 4# 0 callf ;
: command  uart-read
  is0 reset ; then
  dup 1 # = if adrop ok ;  then 
  dup 2 # = if goto fetch then
  dup 3 # = if goto store then
  dup 4 # = if goto run then ;

entry:
: main  init  { uart-read $aa # = if command drop then }

save load.bin
bye

