\ mf.f
\
\ MTV Forth.

fload f.f
start

0 syscall init
1 syscall poll
2 syscall receive
3 syscall send
4 syscall freeram
5 syscall sync-flash
6 syscall exit

\ Dictionary entry header.
\
\ 00  word  Pointer to last header.
\ 04  word  Pointer to data/code.
\ 08  byte  Flags.
\ 09  byte  Name length.
\ 0a        Name string.
\
\ Flags.
\
\ 0   Immediate
\

label s1 " Hello!"
label s2 " Hell0!"

variable last

\ This one also does two adrops if false...
: compare-chars ( c1 c2 -- true/false )
  = is0  adrop adrop ;  then ;

\ Not that the input parameters are on the address stack, while the
\ output is pushed at the data stack.
: strcmp ( s1 s2 -- true/false )
  c@+ aswap c@
  compare-chars is0 ; then drop  c@+
  {
    c@+ aswap c@+ compare-chars is0 swap drop ; then drop
    1 # - is0 drop true # ; then
  }

: last-item  @ adrop >a ;

entry:
: main  $17 # init  s1 ia# s2 ia# strcmp '6' # + send  exit ;

save mf.bin
bye

