#include <stdio.h>

int main(int argc, char **argv) {
	FILE *file;
	int c;
	int i=8;

	if(argc != 2) {
		fprintf(stderr,"Usage: db infile\n");
		return -1;
	}

	if((file = fopen(argv[1],"r")) == NULL) {
		fprintf(stderr,"Can not open file.\n");
		return -1;
	}

	printf(".db ");
	while((c = fgetc(file)) != EOF) {
		if(i!=8) printf(",");
		printf("0x%02x",c);
		if(--i == 0) {
			printf("\n.db ");
			i = 8;
		}
	}
	printf("\n\n");

	fclose(file);
	return 0;
}

